/* Programme d'horloge */

/* Définir les broches utilisées pour l'affichage */
#define LATCH_DIO 4
#define CLK_DIO 7
#define DATA_DIO 8

/* Définir les boutons poussoirs */

#define bouton_HEURE A1   // Incremente la valeur
#define bouton_MINUTE A2  // Decremente la valeur

int etat_bouton_heure = HIGH;  // etat du bouton heure
int etat_bouton_minute = HIGH;  // etat du bouton minute
int dernier_etat_bouton_heure = HIGH;  // etat du bouton heure
int dernier_etat_bouton_minute = HIGH;  // etat du bouton minute


/* Initialiser les registres utilisés pour gérer le temps */  
unsigned long temps_actuel;      // Temps actuel en mS
unsigned long temps_precedent;   // Temps auquel le compteur a été actualisé la dernière fois

byte secondes = 00;           // Comptage des secondes
byte minutes = 00;           // Comptage des minutes
byte heures = 12;            // Comptage des heures

/* Dessins des nombres de 0 a 9 sans point decimal */
//const byte SEGMENT_MAP[] = {0xC0,0xF9,0xA4,0xB0,0x99,0x92,0x82,0xF8,0X80,0X90};
/* idem avec point décimal */
//const byte SEGMENT_MAP_DOT[] = {0x40,0x79,0x24,0x30,0x19,0x12,0x02,0x78,0X00,0X10};
/* Dessins des nombres binaires de 0 à 59 */
const byte SEGMENT_MAP[] = {0xFF,0xFD,0xFB,0xF9,0xF7,0xF5,0xF3,0xF1,0xEF,0xED,0xEB,0xE9,0xE7,0xE5,0xE3,0xE1,0xDF,0xDD,0xDB,0xD9,0xD7,0xD5,0xD3,0xD1,0xCF,0xCD,0xCB,0xC9,0xC7,0xC5,0xC3,0xC1,0xFE,0xFC,0xFA,0xF8,0xF6,0xF4,0xF2,0xF0,0xEE,0xEC,0xEA,0xE8,0xE6,0xE4,0xE2,0xE0,0xDE,0xDC,0xDA,0xD8,0xD6,0xD4,0xD2,0xD0,0xCE,0xCC,0xCA,0xC8};

/* Dessins des nombres binaires de 0 à 59 avec point à renseigner */

/* Accès aux 4 afficheurs */
const byte SEGMENT_SELECT[] = {0xF1,0xF2,0xF4,0xF8};

void setup() {
  Serial.begin(9600);             // Initialiser port série
  
  /* Configurer les broches de sortie */
  pinMode(LATCH_DIO,OUTPUT);
  pinMode(CLK_DIO,OUTPUT);
  pinMode(DATA_DIO,OUTPUT);
  
  /* Configurer les broches d'entrée */
  pinMode(bouton_HEURE, INPUT);    // Définir Bouton 1 en entrée
  pinMode(bouton_MINUTE, INPUT);   // Définir Bouton 2 en entrée
  
temps_actuel = millis();         // Temps actuel en mS
temps_precedent = 0;             // Car on vient de démarrer l'Arduino
  
  
}

/* ===== PROGRAMME PRINCIPAL ===== */
void loop() {

  etat_bouton_heure = digitalRead(bouton_HEURE);
  if((etat_bouton_heure != dernier_etat_bouton_heure) && (etat_bouton_heure == LOW))
  {
    heures ++;
      if (heures == 24)
      {
      heures = 0;
      } 
  }
  dernier_etat_bouton_heure = etat_bouton_heure;
  
  etat_bouton_minute = digitalRead(bouton_MINUTE);
  if((etat_bouton_minute != dernier_etat_bouton_minute) && (etat_bouton_minute == LOW))
  {
    minutes ++;
      if (minutes == 60) //était à 59, une erreur ?
      {
      minutes = 0;
      } 
  }
  dernier_etat_bouton_minute = etat_bouton_minute;

  
  horloge();

  WriteNumber(heures, minutes,secondes);
}


/* ===== DEFINITION DES FONCTIONS UTILISEES ===== */

/* Programme de fonctionnement de l'horloge */
void horloge()
 {

   /* Mesurer temps actuel */
    temps_actuel = millis();
   /* Si une seconde s'est écoulée, ajouter un au compteur de secondes */
   if (temps_actuel - temps_precedent > 1000)
   {
       /* Remettre le garde temps au temps actuel */
       temps_precedent = temps_actuel;
       secondes ++;
       Serial.println(String(heures) + ":" + String(minutes) + ":" + String(secondes));
       if (secondes == 60)
       {
           secondes = 0;
           minutes ++; 
           if (minutes == 60)
           {
               minutes = 0;
               heures ++;
               if (heures == 24)
               {
               heures = 0;
               }
           }
       }  
     }
 }
 

/* Ecrire un nombre entre 0 et 9999 sur l'afficheur */
void WriteNumber(byte heures, byte minutes, byte secondes)
{
    //Ecriture des secondes
    WriteNumberToSegment(3 , secondes);
    //Ecriture des minutes
    WriteNumberToSegment(1 , minutes);
    //Ecriture des heures
    WriteNumberToSegment(0 , heures);
  
}

/* Ecrire un nombre entre 0 et 59 sur un des 3 digits de droite de l'afficheur */
void WriteNumberToSegment(byte Segment, byte Value)
{
  digitalWrite(LATCH_DIO,LOW);
  shiftOut(DATA_DIO, CLK_DIO, MSBFIRST, SEGMENT_MAP[Value]);
  shiftOut(DATA_DIO, CLK_DIO, MSBFIRST, SEGMENT_SELECT[Segment] );
  digitalWrite(LATCH_DIO,HIGH);    
}
